<template>
  <div class="count">

    <div class="count__top">
      <h1 class="count__title">Счет&nbsp;<b>{{ balance | rubCurrency }}</b></h1>

      <!--<button type="button" class="button button&#45;&#45;green count__top-btn">-->
      <!--<icon-plus />-->
      <!--Пополнить-->
      <!--</button>-->
    </div>

    <div class="table-wrapper" v-if="events.length">
      <table class="table count-table">
        <tbody>
        <tr v-for="(event, index) in limitedEvents" :key="index">
          <td class="count-table__date-cell">
            <span class="count-table__date" v-html="getEventDateInfo(event)"></span>
          </td>
          <td class="count-table__type-cell">
              <span class="count-table__type">
                {{ isChangePositive(event) ? 'Зачисление' : 'Оплата бронирования' }}
              </span>
          </td>
          <td class="count-table__count-cell">
              <span v-if="isChangePositive(event)"
                    class="count-table__count count-table__count--plus">
                <icon-plus/> {{ Math.abs(event.change) | rubCurrency }}
              </span>
            <span v-else
                  class="count-table__count count-table__count--minus">
                <icon-minus/> {{ Math.abs(event.change) | rubCurrency }}
              </span>
          </td>
        </tr>
        </tbody>

      </table>
    </div>

    <template v-else>
      Нет операций по лицевому счету
    </template>

    <button v-if="(currentPage * eventsPerPage) < events.length"
            type="button"
            class="button button--gray count__show-more"
            @click="showMoreEvents">
      <icon-plus/>
      Показать еще
    </button>
  </div>

</template>

<script>
  import { mapGetters } from 'vuex';

  import IconPlus from '../../components/icons/IconPlus';
  import IconMinus from '../../components/icons/IconMinus';

  import { getSeoBySlug } from '../../service/deliroom-service';
  import {months, weekDays} from "../../assets/js/helpers/consts";

  export default {
    name: 'ProfilePage',
    components: {
      IconMinus,
      IconPlus
    },
    data: () => ({
      eventsPerPage: 10,
      currentPage: 1,

      months: months,
      weekDays: weekDays
    }),

    asyncData: async () => ({
      meta: await getSeoBySlug('/personal/account'),
    }),

    computed: {
      ...mapGetters({
        balance: 'user/balance'
      }),

      events() {
        return [ ...this.$store.state.user.accountInfo ].sort((a, b) => {
          const aDate = Number(new Date(a.date));
          const bDate = Number(new Date(b.date));

          if (aDate < bDate) {
            return 1;
          }

          if (aDate > bDate) {
            return -1;
          }

          return 0;
        });
      },

      limitedEvents() {
        return this.events.filter((item, index) =>
          index < (this.eventsPerPage * this.currentPage))
      },
    },

    methods: {
      showMoreEvents() {
        this.currentPage += 1;
      },

      getEventDateInfo(event) {
        const date = new Date(event.date);
        const getTimeLabel = (date) => date.toLocaleTimeString().substr(0, 5);

        return `<b>${this.weekDays[date.getDay()].short} ${date.getDate()} ${this.months[date.getMonth()]}</b>,
                ${getTimeLabel(date)}`
      },

      isChangePositive(event) {
        return Number(event.change) > 0;
      },
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .count {
    &__top {
      display: flex;
      align-items: center;

      margin-bottom: rem(32);

      @media (max-width: $mobile-width) {
        flex-flow: column;
        align-items: flex-start;

        margin-bottom: rem(40);
      }
    }

    &__title {
      @include h2;
      color: $dark-gray;
      white-space: nowrap;

      b {
        font-weight: inherit;
        color: $black;
      }
    }

    &__top-btn {
      height: rem(50);
      margin-left: rem(40);
      padding: 0 rem(30) 0 rem(24);

      svg {
        width: rem(12);
        height: rem(12);
        margin-right: rem(10);

        stroke: $white;
      }

      @media (max-width: $mobile-width) {
        margin-left: 0;
        margin-top: rem(16);
      }
    }

    &__show-more {
      height: rem(60);
      padding: 0 rem(36) 0 rem(28);
      margin-top: rem(34);

      svg {
        width: rem(12);
        height: rem(12);

        margin-right: rem(10);
      }
    }

    .table-wrapper {
      @include table;
    }

    .count-table {
      td {
        padding-top: rem(22);
        padding-bottom: rem(22);

        font-weight: 600 !important;
        border-width: rem(1);
      }

      tbody tr:last-child td {
        border-bottom: none;
      }

      &__date-cell {
        width: rem(256);
      }

      &__type-cell {
        width: rem(290);
      }

      &__date {
        color: rgba($black, .5);

        b {
          font-weight: inherit;
          color: $black;
        }
      }

      &__type {
        color: rgba($black, .5);
      }

      &__count {
        display: inline-flex;
        align-items: center;

        svg {
          margin-right: rem(10);
        }

        &--plus {
          color: $green;

          svg {
            width: rem(10);
            height: rem(10);

            stroke: $green;
          }
        }

        &--minus {
          color: $black;

          svg {
            width: rem(10);
          }
        }
      }
    }
  }
</style>

